Images
Create image
post /images/generations
Creates an image given a prompt. Learn more.
Body Parameters
-
prompt: stringA text description of the desired image(s). The maximum length is 32000 characters for the GPT image models, 1000 characters for
dall-e-2and 4000 characters fordall-e-3. -
background: optional "transparent" or "opaque" or "auto"Allows to set transparency for the background of the generated image(s). This parameter is only supported for the GPT image models. Must be one of
transparent,opaqueorauto(default value). Whenautois used, the model will automatically determine the best background for the image.If
transparent, the output format needs to support transparency, so it should be set to eitherpng(default value) orwebp.-
"transparent" -
"opaque" -
"auto"
-
-
model: optional string or ImageModelThe model to use for image generation. One of
dall-e-2,dall-e-3, or a GPT image model (gpt-image-1,gpt-image-1-mini,gpt-image-1.5). Defaults todall-e-2unless a parameter specific to the GPT image models is used.-
string -
ImageModel = "gpt-image-1.5" or "dall-e-2" or "dall-e-3" or 2 more-
"gpt-image-1.5" -
"dall-e-2" -
"dall-e-3" -
"gpt-image-1" -
"gpt-image-1-mini"
-
-
-
moderation: optional "low" or "auto"Control the content-moderation level for images generated by the GPT image models. Must be either
lowfor less restrictive filtering orauto(default value).-
"low" -
"auto"
-
-
n: optional numberThe number of images to generate. Must be between 1 and 10. For
dall-e-3, onlyn=1is supported. -
output_compression: optional numberThe compression level (0-100%) for the generated images. This parameter is only supported for the GPT image models with the
webporjpegoutput formats, and defaults to 100. -
output_format: optional "png" or "jpeg" or "webp"The format in which the generated images are returned. This parameter is only supported for the GPT image models. Must be one of
png,jpeg, orwebp.-
"png" -
"jpeg" -
"webp"
-
-
partial_images: optional numberThe number of partial images to generate. This parameter is used for streaming responses that return partial images. Value must be between 0 and 3. When set to 0, the response will be a single image sent in one streaming event.
Note that the final image may be sent before the full number of partial images are generated if the full image is generated more quickly.
-
quality: optional "standard" or "hd" or "low" or 3 moreThe quality of the image that will be generated.
-
auto(default value) will automatically select the best quality for the given model. -
high,mediumandloware supported for the GPT image models. -
hdandstandardare supported fordall-e-3. -
standardis the only option fordall-e-2. -
"standard" -
"hd" -
"low" -
"medium" -
"high" -
"auto"
-
-
response_format: optional "url" or "b64_json"The format in which generated images with
dall-e-2anddall-e-3are returned. Must be one ofurlorb64_json. URLs are only valid for 60 minutes after the image has been generated. This parameter isn't supported for the GPT image models, which always return base64-encoded images.-
"url" -
"b64_json"
-
-
size: optional string or "auto" or "1024x1024" or "1536x1024" or 5 moreThe size of the generated images. For
gpt-image-2andgpt-image-2-2026-04-21, arbitrary resolutions are supported asWIDTHxHEIGHTstrings, for example1536x864. Width and height must both be divisible by 16 and the requested aspect ratio must be between 1:3 and 3:1. Resolutions above2560x1440are experimental, and the maximum supported resolution is3840x2160. The requested size must also satisfy the model's current pixel and edge limits. The standard sizes1024x1024,1536x1024, and1024x1536are supported by the GPT image models;autois supported for models that allow automatic sizing. Fordall-e-2, use one of256x256,512x512, or1024x1024. Fordall-e-3, use one of1024x1024,1792x1024, or1024x1792.-
string -
"auto" or "1024x1024" or "1536x1024" or 5 moreThe size of the generated images. For
gpt-image-2andgpt-image-2-2026-04-21, arbitrary resolutions are supported asWIDTHxHEIGHTstrings, for example1536x864. Width and height must both be divisible by 16 and the requested aspect ratio must be between 1:3 and 3:1. Resolutions above2560x1440are experimental, and the maximum supported resolution is3840x2160. The requested size must also satisfy the model's current pixel and edge limits. The standard sizes1024x1024,1536x1024, and1024x1536are supported by the GPT image models;autois supported for models that allow automatic sizing. Fordall-e-2, use one of256x256,512x512, or1024x1024. Fordall-e-3, use one of1024x1024,1792x1024, or1024x1792.-
"auto" -
"1024x1024" -
"1536x1024" -
"1024x1536" -
"256x256" -
"512x512" -
"1792x1024" -
"1024x1792"
-
-
-
stream: optional booleanGenerate the image in streaming mode. Defaults to
false. See the Image generation guide for more information. This parameter is only supported for the GPT image models. -
style: optional "vivid" or "natural"The style of the generated images. This parameter is only supported for
dall-e-3. Must be one ofvividornatural. Vivid causes the model to lean towards generating hyper-real and dramatic images. Natural causes the model to produce more natural, less hyper-real looking images.-
"vivid" -
"natural"
-
-
user: optional stringA unique identifier representing your end-user, which can help OpenAI to monitor and detect abuse. Learn more.
Returns
-
ImagesResponse object { created, background, data, 4 more }The response from the image generation endpoint.
-
created: numberThe Unix timestamp (in seconds) of when the image was created.
-
background: optional "transparent" or "opaque"The background parameter used for the image generation. Either
transparentoropaque.-
"transparent" -
"opaque"
-
-
data: optional array of ImageThe list of generated images.
-
b64_json: optional stringThe base64-encoded JSON of the generated image. Returned by default for the GPT image models, and only present if
response_formatis set tob64_jsonfordall-e-2anddall-e-3. -
revised_prompt: optional stringFor
dall-e-3only, the revised prompt that was used to generate the image. -
url: optional stringWhen using
dall-e-2ordall-e-3, the URL of the generated image ifresponse_formatis set tourl(default value). Unsupported for the GPT image models.
-
-
output_format: optional "png" or "webp" or "jpeg"The output format of the image generation. Either
png,webp, orjpeg.-
"png" -
"webp" -
"jpeg"
-
-
quality: optional "low" or "medium" or "high"The quality of the image generated. Either
low,medium, orhigh.-
"low" -
"medium" -
"high"
-
-
size: optional "1024x1024" or "1024x1536" or "1536x1024"The size of the image generated. Either
1024x1024,1024x1536, or1536x1024.-
"1024x1024" -
"1024x1536" -
"1536x1024"
-
-
usage: optional object { input_tokens, input_tokens_details, output_tokens, 2 more }For
gpt-image-1only, the token usage information for the image generation.-
input_tokens: numberThe number of tokens (images and text) in the input prompt.
-
input_tokens_details: object { image_tokens, text_tokens }The input tokens detailed information for the image generation.
-
image_tokens: numberThe number of image tokens in the input prompt.
-
text_tokens: numberThe number of text tokens in the input prompt.
-
-
output_tokens: numberThe number of output tokens generated by the model.
-
total_tokens: numberThe total number of tokens (images and text) used for the image generation.
-
output_tokens_details: optional object { image_tokens, text_tokens }The output token details for the image generation.
-
image_tokens: numberThe number of image output tokens generated by the model.
-
text_tokens: numberThe number of text output tokens generated by the model.
-
-
-
Example
curl https://api.openai.com/v1/images/generations \
-H 'Content-Type: application/json' \
-H "Authorization: Bearer $OPENAI_API_KEY" \
-d '{
"prompt": "A cute baby sea otter",
"background": "transparent",
"moderation": "low",
"n": 1,
"output_compression": 100,
"output_format": "png",
"partial_images": 1,
"quality": "medium",
"response_format": "url",
"style": "vivid",
"user": "user-1234"
}'
Response
{
"created": 0,
"background": "transparent",
"data": [
{
"b64_json": "b64_json",
"revised_prompt": "revised_prompt",
"url": "https://example.com"
}
],
"output_format": "png",
"quality": "low",
"size": "1024x1024",
"usage": {
"input_tokens": 0,
"input_tokens_details": {
"image_tokens": 0,
"text_tokens": 0
},
"output_tokens": 0,
"total_tokens": 0,
"output_tokens_details": {
"image_tokens": 0,
"text_tokens": 0
}
}
}
Generate image
curl https://api.openai.com/v1/images/generations \
-H "Content-Type: application/json" \
-H "Authorization: Bearer $OPENAI_API_KEY" \
-d '{
"model": "gpt-image-1.5",
"prompt": "A cute baby sea otter",
"n": 1,
"size": "1024x1024"
}'
Response
{
"created": 1713833628,
"data": [
{
"b64_json": "..."
}
],
"usage": {
"total_tokens": 100,
"input_tokens": 50,
"output_tokens": 50,
"input_tokens_details": {
"text_tokens": 10,
"image_tokens": 40
}
}
}
Streaming
curl https://api.openai.com/v1/images/generations \
-H "Content-Type: application/json" \
-H "Authorization: Bearer $OPENAI_API_KEY" \
-d '{
"model": "gpt-image-1.5",
"prompt": "A cute baby sea otter",
"n": 1,
"size": "1024x1024",
"stream": true
}' \
--no-buffer
Response
event: image_generation.partial_image
data: {"type":"image_generation.partial_image","b64_json":"...","partial_image_index":0}
event: image_generation.completed
data: {"type":"image_generation.completed","b64_json":"...","usage":{"total_tokens":100,"input_tokens":50,"output_tokens":50,"input_tokens_details":{"text_tokens":10,"image_tokens":40}}}
Create image edit
post /images/edits
Creates an edited or extended image given one or more source images and a prompt. This endpoint supports GPT Image models (gpt-image-1.5, gpt-image-1, gpt-image-1-mini, and chatgpt-image-latest) and dall-e-2.
Body Parameters
-
images: array of object { file_id, image_url }Input image references to edit. For GPT image models, you can provide up to 16 images.
-
file_id: optional stringThe File API ID of an uploaded image to use as input.
-
image_url: optional stringA fully qualified URL or base64-encoded data URL.
-
-
prompt: stringA text description of the desired image edit.
-
background: optional "transparent" or "opaque" or "auto"Background behavior for generated image output.
-
"transparent" -
"opaque" -
"auto"
-
-
input_fidelity: optional "high" or "low"Controls fidelity to the original input image(s).
-
"high" -
"low"
-
-
mask: optional object { file_id, image_url }Reference an input image by either URL or uploaded file ID. Provide exactly one of
image_urlorfile_id.-
file_id: optional stringThe File API ID of an uploaded image to use as input.
-
image_url: optional stringA fully qualified URL or base64-encoded data URL.
-
-
model: optional string or "gpt-image-1.5" or "gpt-image-1" or "gpt-image-1-mini" or "chatgpt-image-latest"The model to use for image editing.
-
string -
"gpt-image-1.5" or "gpt-image-1" or "gpt-image-1-mini" or "chatgpt-image-latest"The model to use for image editing.
-
"gpt-image-1.5" -
"gpt-image-1" -
"gpt-image-1-mini" -
"chatgpt-image-latest"
-
-
-
moderation: optional "low" or "auto"Moderation level for GPT image models.
-
"low" -
"auto"
-
-
n: optional numberThe number of edited images to generate.
-
output_compression: optional numberCompression level for
jpegorwebpoutput. -
output_format: optional "png" or "jpeg" or "webp"Output image format. Supported for GPT image models.
-
"png" -
"jpeg" -
"webp"
-
-
partial_images: optional numberThe number of partial images to generate. This parameter is used for streaming responses that return partial images. Value must be between 0 and 3. When set to 0, the response will be a single image sent in one streaming event.
Note that the final image may be sent before the full number of partial images are generated if the full image is generated more quickly.
-
quality: optional "low" or "medium" or "high" or "auto"Output quality for GPT image models.
-
"low" -
"medium" -
"high" -
"auto"
-
-
size: optional "auto" or "1024x1024" or "1536x1024" or "1024x1536"Requested output image size.
-
"auto" -
"1024x1024" -
"1536x1024" -
"1024x1536"
-
-
stream: optional booleanStream partial image results as events.
-
user: optional stringA unique identifier representing your end-user, which can help OpenAI monitor and detect abuse.
Returns
-
ImagesResponse object { created, background, data, 4 more }The response from the image generation endpoint.
-
created: numberThe Unix timestamp (in seconds) of when the image was created.
-
background: optional "transparent" or "opaque"The background parameter used for the image generation. Either
transparentoropaque.-
"transparent" -
"opaque"
-
-
data: optional array of ImageThe list of generated images.
-
b64_json: optional stringThe base64-encoded JSON of the generated image. Returned by default for the GPT image models, and only present if
response_formatis set tob64_jsonfordall-e-2anddall-e-3. -
revised_prompt: optional stringFor
dall-e-3only, the revised prompt that was used to generate the image. -
url: optional stringWhen using
dall-e-2ordall-e-3, the URL of the generated image ifresponse_formatis set tourl(default value). Unsupported for the GPT image models.
-
-
output_format: optional "png" or "webp" or "jpeg"The output format of the image generation. Either
png,webp, orjpeg.-
"png" -
"webp" -
"jpeg"
-
-
quality: optional "low" or "medium" or "high"The quality of the image generated. Either
low,medium, orhigh.-
"low" -
"medium" -
"high"
-
-
size: optional "1024x1024" or "1024x1536" or "1536x1024"The size of the image generated. Either
1024x1024,1024x1536, or1536x1024.-
"1024x1024" -
"1024x1536" -
"1536x1024"
-
-
usage: optional object { input_tokens, input_tokens_details, output_tokens, 2 more }For
gpt-image-1only, the token usage information for the image generation.-
input_tokens: numberThe number of tokens (images and text) in the input prompt.
-
input_tokens_details: object { image_tokens, text_tokens }The input tokens detailed information for the image generation.
-
image_tokens: numberThe number of image tokens in the input prompt.
-
text_tokens: numberThe number of text tokens in the input prompt.
-
-
output_tokens: numberThe number of output tokens generated by the model.
-
total_tokens: numberThe total number of tokens (images and text) used for the image generation.
-
output_tokens_details: optional object { image_tokens, text_tokens }The output token details for the image generation.
-
image_tokens: numberThe number of image output tokens generated by the model.
-
text_tokens: numberThe number of text output tokens generated by the model.
-
-
-
Example
curl https://api.openai.com/v1/images/edits \
-H 'Content-Type: application/json' \
-H "Authorization: Bearer $OPENAI_API_KEY" \
-d '{
"images": [
{
"image_url": "https://example.com/source-image.png"
}
],
"prompt": "Add a watercolor effect to this image",
"background": "transparent",
"model": "gpt-image-1.5",
"moderation": "auto",
"n": 1,
"output_compression": 100,
"output_format": "png",
"partial_images": 1,
"quality": "high",
"size": "1024x1024",
"user": "user-1234"
}'
Response
{
"created": 0,
"background": "transparent",
"data": [
{
"b64_json": "b64_json",
"revised_prompt": "revised_prompt",
"url": "https://example.com"
}
],
"output_format": "png",
"quality": "low",
"size": "1024x1024",
"usage": {
"input_tokens": 0,
"input_tokens_details": {
"image_tokens": 0,
"text_tokens": 0
},
"output_tokens": 0,
"total_tokens": 0,
"output_tokens_details": {
"image_tokens": 0,
"text_tokens": 0
}
}
}
Edit image
curl -s -D >(grep -i x-request-id >&2) \
-o >(jq -r '.data[0].b64_json' | base64 --decode > gift-basket.png) \
-X POST "https://api.openai.com/v1/images/edits" \
-H "Authorization: Bearer $OPENAI_API_KEY" \
-F "model=gpt-image-1.5" \
-F "image[]=@body-lotion.png" \
-F "image[]=@bath-bomb.png" \
-F "image[]=@incense-kit.png" \
-F "image[]=@soap.png" \
-F 'prompt=Create a lovely gift basket with these four items in it'
Streaming
curl -s -N -X POST "https://api.openai.com/v1/images/edits" \
-H "Authorization: Bearer $OPENAI_API_KEY" \
-F "model=gpt-image-1.5" \
-F "image[]=@body-lotion.png" \
-F "image[]=@bath-bomb.png" \
-F "image[]=@incense-kit.png" \
-F "image[]=@soap.png" \
-F 'prompt=Create a lovely gift basket with these four items in it' \
-F "stream=true"
Response
event: image_edit.partial_image
data: {"type":"image_edit.partial_image","b64_json":"...","partial_image_index":0}
event: image_edit.completed
data: {"type":"image_edit.completed","b64_json":"...","usage":{"total_tokens":100,"input_tokens":50,"output_tokens":50,"input_tokens_details":{"text_tokens":10,"image_tokens":40}}}
Create image variation
post /images/variations
Creates a variation of a given image. This endpoint only supports dall-e-2.
Returns
-
ImagesResponse object { created, background, data, 4 more }The response from the image generation endpoint.
-
created: numberThe Unix timestamp (in seconds) of when the image was created.
-
background: optional "transparent" or "opaque"The background parameter used for the image generation. Either
transparentoropaque.-
"transparent" -
"opaque"
-
-
data: optional array of ImageThe list of generated images.
-
b64_json: optional stringThe base64-encoded JSON of the generated image. Returned by default for the GPT image models, and only present if
response_formatis set tob64_jsonfordall-e-2anddall-e-3. -
revised_prompt: optional stringFor
dall-e-3only, the revised prompt that was used to generate the image. -
url: optional stringWhen using
dall-e-2ordall-e-3, the URL of the generated image ifresponse_formatis set tourl(default value). Unsupported for the GPT image models.
-
-
output_format: optional "png" or "webp" or "jpeg"The output format of the image generation. Either
png,webp, orjpeg.-
"png" -
"webp" -
"jpeg"
-
-
quality: optional "low" or "medium" or "high"The quality of the image generated. Either
low,medium, orhigh.-
"low" -
"medium" -
"high"
-
-
size: optional "1024x1024" or "1024x1536" or "1536x1024"The size of the image generated. Either
1024x1024,1024x1536, or1536x1024.-
"1024x1024" -
"1024x1536" -
"1536x1024"
-
-
usage: optional object { input_tokens, input_tokens_details, output_tokens, 2 more }For
gpt-image-1only, the token usage information for the image generation.-
input_tokens: numberThe number of tokens (images and text) in the input prompt.
-
input_tokens_details: object { image_tokens, text_tokens }The input tokens detailed information for the image generation.
-
image_tokens: numberThe number of image tokens in the input prompt.
-
text_tokens: numberThe number of text tokens in the input prompt.
-
-
output_tokens: numberThe number of output tokens generated by the model.
-
total_tokens: numberThe total number of tokens (images and text) used for the image generation.
-
output_tokens_details: optional object { image_tokens, text_tokens }The output token details for the image generation.
-
image_tokens: numberThe number of image output tokens generated by the model.
-
text_tokens: numberThe number of text output tokens generated by the model.
-
-
-
Example
curl https://api.openai.com/v1/images/variations \
-H 'Content-Type: multipart/form-data' \
-H "Authorization: Bearer $OPENAI_API_KEY" \
-F 'image=@/path/to/image' \
-F n=1 \
-F response_format=url \
-F size=1024x1024 \
-F user=user-1234
Response
{
"created": 0,
"background": "transparent",
"data": [
{
"b64_json": "b64_json",
"revised_prompt": "revised_prompt",
"url": "https://example.com"
}
],
"output_format": "png",
"quality": "low",
"size": "1024x1024",
"usage": {
"input_tokens": 0,
"input_tokens_details": {
"image_tokens": 0,
"text_tokens": 0
},
"output_tokens": 0,
"total_tokens": 0,
"output_tokens_details": {
"image_tokens": 0,
"text_tokens": 0
}
}
}
Example
curl https://api.openai.com/v1/images/variations \
-H "Authorization: Bearer $OPENAI_API_KEY" \
-F image="@otter.png" \
-F n=2 \
-F size="1024x1024"
Response
{
"created": 1589478378,
"data": [
{
"url": "https://..."
},
{
"url": "https://..."
}
]
}
Domain Types
Image
-
Image object { b64_json, revised_prompt, url }Represents the content or the URL of an image generated by the OpenAI API.
-
b64_json: optional stringThe base64-encoded JSON of the generated image. Returned by default for the GPT image models, and only present if
response_formatis set tob64_jsonfordall-e-2anddall-e-3. -
revised_prompt: optional stringFor
dall-e-3only, the revised prompt that was used to generate the image. -
url: optional stringWhen using
dall-e-2ordall-e-3, the URL of the generated image ifresponse_formatis set tourl(default value). Unsupported for the GPT image models.
-
Image Edit Completed Event
-
ImageEditCompletedEvent object { b64_json, background, created_at, 5 more }Emitted when image editing has completed and the final image is available.
-
b64_json: stringBase64-encoded final edited image data, suitable for rendering as an image.
-
background: "transparent" or "opaque" or "auto"The background setting for the edited image.
-
"transparent" -
"opaque" -
"auto"
-
-
created_at: numberThe Unix timestamp when the event was created.
-
output_format: "png" or "webp" or "jpeg"The output format for the edited image.
-
"png" -
"webp" -
"jpeg"
-
-
quality: "low" or "medium" or "high" or "auto"The quality setting for the edited image.
-
"low" -
"medium" -
"high" -
"auto"
-
-
size: "1024x1024" or "1024x1536" or "1536x1024" or "auto"The size of the edited image.
-
"1024x1024" -
"1024x1536" -
"1536x1024" -
"auto"
-
-
type: "image_edit.completed"The type of the event. Always
image_edit.completed."image_edit.completed"
-
usage: object { input_tokens, input_tokens_details, output_tokens, total_tokens }For the GPT image models only, the token usage information for the image generation.
-
input_tokens: numberThe number of tokens (images and text) in the input prompt.
-
input_tokens_details: object { image_tokens, text_tokens }The input tokens detailed information for the image generation.
-
image_tokens: numberThe number of image tokens in the input prompt.
-
text_tokens: numberThe number of text tokens in the input prompt.
-
-
output_tokens: numberThe number of image tokens in the output image.
-
total_tokens: numberThe total number of tokens (images and text) used for the image generation.
-
-
Image Edit Partial Image Event
-
ImageEditPartialImageEvent object { b64_json, background, created_at, 5 more }Emitted when a partial image is available during image editing streaming.
-
b64_json: stringBase64-encoded partial image data, suitable for rendering as an image.
-
background: "transparent" or "opaque" or "auto"The background setting for the requested edited image.
-
"transparent" -
"opaque" -
"auto"
-
-
created_at: numberThe Unix timestamp when the event was created.
-
output_format: "png" or "webp" or "jpeg"The output format for the requested edited image.
-
"png" -
"webp" -
"jpeg"
-
-
partial_image_index: number0-based index for the partial image (streaming).
-
quality: "low" or "medium" or "high" or "auto"The quality setting for the requested edited image.
-
"low" -
"medium" -
"high" -
"auto"
-
-
size: "1024x1024" or "1024x1536" or "1536x1024" or "auto"The size of the requested edited image.
-
"1024x1024" -
"1024x1536" -
"1536x1024" -
"auto"
-
-
type: "image_edit.partial_image"The type of the event. Always
image_edit.partial_image."image_edit.partial_image"
-
Image Edit Stream Event
-
ImageEditStreamEvent = ImageEditPartialImageEvent or ImageEditCompletedEventEmitted when a partial image is available during image editing streaming.
-
ImageEditPartialImageEvent object { b64_json, background, created_at, 5 more }Emitted when a partial image is available during image editing streaming.
-
b64_json: stringBase64-encoded partial image data, suitable for rendering as an image.
-
background: "transparent" or "opaque" or "auto"The background setting for the requested edited image.
-
"transparent" -
"opaque" -
"auto"
-
-
created_at: numberThe Unix timestamp when the event was created.
-
output_format: "png" or "webp" or "jpeg"The output format for the requested edited image.
-
"png" -
"webp" -
"jpeg"
-
-
partial_image_index: number0-based index for the partial image (streaming).
-
quality: "low" or "medium" or "high" or "auto"The quality setting for the requested edited image.
-
"low" -
"medium" -
"high" -
"auto"
-
-
size: "1024x1024" or "1024x1536" or "1536x1024" or "auto"The size of the requested edited image.
-
"1024x1024" -
"1024x1536" -
"1536x1024" -
"auto"
-
-
type: "image_edit.partial_image"The type of the event. Always
image_edit.partial_image."image_edit.partial_image"
-
-
ImageEditCompletedEvent object { b64_json, background, created_at, 5 more }Emitted when image editing has completed and the final image is available.
-
b64_json: stringBase64-encoded final edited image data, suitable for rendering as an image.
-
background: "transparent" or "opaque" or "auto"The background setting for the edited image.
-
"transparent" -
"opaque" -
"auto"
-
-
created_at: numberThe Unix timestamp when the event was created.
-
output_format: "png" or "webp" or "jpeg"The output format for the edited image.
-
"png" -
"webp" -
"jpeg"
-
-
quality: "low" or "medium" or "high" or "auto"The quality setting for the edited image.
-
"low" -
"medium" -
"high" -
"auto"
-
-
size: "1024x1024" or "1024x1536" or "1536x1024" or "auto"The size of the edited image.
-
"1024x1024" -
"1024x1536" -
"1536x1024" -
"auto"
-
-
type: "image_edit.completed"The type of the event. Always
image_edit.completed."image_edit.completed"
-
usage: object { input_tokens, input_tokens_details, output_tokens, total_tokens }For the GPT image models only, the token usage information for the image generation.
-
input_tokens: numberThe number of tokens (images and text) in the input prompt.
-
input_tokens_details: object { image_tokens, text_tokens }The input tokens detailed information for the image generation.
-
image_tokens: numberThe number of image tokens in the input prompt.
-
text_tokens: numberThe number of text tokens in the input prompt.
-
-
output_tokens: numberThe number of image tokens in the output image.
-
total_tokens: numberThe total number of tokens (images and text) used for the image generation.
-
-
-
Image Gen Completed Event
-
ImageGenCompletedEvent object { b64_json, background, created_at, 5 more }Emitted when image generation has completed and the final image is available.
-
b64_json: stringBase64-encoded image data, suitable for rendering as an image.
-
background: "transparent" or "opaque" or "auto"The background setting for the generated image.
-
"transparent" -
"opaque" -
"auto"
-
-
created_at: numberThe Unix timestamp when the event was created.
-
output_format: "png" or "webp" or "jpeg"The output format for the generated image.
-
"png" -
"webp" -
"jpeg"
-
-
quality: "low" or "medium" or "high" or "auto"The quality setting for the generated image.
-
"low" -
"medium" -
"high" -
"auto"
-
-
size: "1024x1024" or "1024x1536" or "1536x1024" or "auto"The size of the generated image.
-
"1024x1024" -
"1024x1536" -
"1536x1024" -
"auto"
-
-
type: "image_generation.completed"The type of the event. Always
image_generation.completed."image_generation.completed"
-
usage: object { input_tokens, input_tokens_details, output_tokens, total_tokens }For the GPT image models only, the token usage information for the image generation.
-
input_tokens: numberThe number of tokens (images and text) in the input prompt.
-
input_tokens_details: object { image_tokens, text_tokens }The input tokens detailed information for the image generation.
-
image_tokens: numberThe number of image tokens in the input prompt.
-
text_tokens: numberThe number of text tokens in the input prompt.
-
-
output_tokens: numberThe number of image tokens in the output image.
-
total_tokens: numberThe total number of tokens (images and text) used for the image generation.
-
-
Image Gen Partial Image Event
-
ImageGenPartialImageEvent object { b64_json, background, created_at, 5 more }Emitted when a partial image is available during image generation streaming.
-
b64_json: stringBase64-encoded partial image data, suitable for rendering as an image.
-
background: "transparent" or "opaque" or "auto"The background setting for the requested image.
-
"transparent" -
"opaque" -
"auto"
-
-
created_at: numberThe Unix timestamp when the event was created.
-
output_format: "png" or "webp" or "jpeg"The output format for the requested image.
-
"png" -
"webp" -
"jpeg"
-
-
partial_image_index: number0-based index for the partial image (streaming).
-
quality: "low" or "medium" or "high" or "auto"The quality setting for the requested image.
-
"low" -
"medium" -
"high" -
"auto"
-
-
size: "1024x1024" or "1024x1536" or "1536x1024" or "auto"The size of the requested image.
-
"1024x1024" -
"1024x1536" -
"1536x1024" -
"auto"
-
-
type: "image_generation.partial_image"The type of the event. Always
image_generation.partial_image."image_generation.partial_image"
-
Image Gen Stream Event
-
ImageGenStreamEvent = ImageGenPartialImageEvent or ImageGenCompletedEventEmitted when a partial image is available during image generation streaming.
-
ImageGenPartialImageEvent object { b64_json, background, created_at, 5 more }Emitted when a partial image is available during image generation streaming.
-
b64_json: stringBase64-encoded partial image data, suitable for rendering as an image.
-
background: "transparent" or "opaque" or "auto"The background setting for the requested image.
-
"transparent" -
"opaque" -
"auto"
-
-
created_at: numberThe Unix timestamp when the event was created.
-
output_format: "png" or "webp" or "jpeg"The output format for the requested image.
-
"png" -
"webp" -
"jpeg"
-
-
partial_image_index: number0-based index for the partial image (streaming).
-
quality: "low" or "medium" or "high" or "auto"The quality setting for the requested image.
-
"low" -
"medium" -
"high" -
"auto"
-
-
size: "1024x1024" or "1024x1536" or "1536x1024" or "auto"The size of the requested image.
-
"1024x1024" -
"1024x1536" -
"1536x1024" -
"auto"
-
-
type: "image_generation.partial_image"The type of the event. Always
image_generation.partial_image."image_generation.partial_image"
-
-
ImageGenCompletedEvent object { b64_json, background, created_at, 5 more }Emitted when image generation has completed and the final image is available.
-
b64_json: stringBase64-encoded image data, suitable for rendering as an image.
-
background: "transparent" or "opaque" or "auto"The background setting for the generated image.
-
"transparent" -
"opaque" -
"auto"
-
-
created_at: numberThe Unix timestamp when the event was created.
-
output_format: "png" or "webp" or "jpeg"The output format for the generated image.
-
"png" -
"webp" -
"jpeg"
-
-
quality: "low" or "medium" or "high" or "auto"The quality setting for the generated image.
-
"low" -
"medium" -
"high" -
"auto"
-
-
size: "1024x1024" or "1024x1536" or "1536x1024" or "auto"The size of the generated image.
-
"1024x1024" -
"1024x1536" -
"1536x1024" -
"auto"
-
-
type: "image_generation.completed"The type of the event. Always
image_generation.completed."image_generation.completed"
-
usage: object { input_tokens, input_tokens_details, output_tokens, total_tokens }For the GPT image models only, the token usage information for the image generation.
-
input_tokens: numberThe number of tokens (images and text) in the input prompt.
-
input_tokens_details: object { image_tokens, text_tokens }The input tokens detailed information for the image generation.
-
image_tokens: numberThe number of image tokens in the input prompt.
-
text_tokens: numberThe number of text tokens in the input prompt.
-
-
output_tokens: numberThe number of image tokens in the output image.
-
total_tokens: numberThe total number of tokens (images and text) used for the image generation.
-
-
-
Image Model
-
ImageModel = "gpt-image-1.5" or "dall-e-2" or "dall-e-3" or 2 more-
"gpt-image-1.5" -
"dall-e-2" -
"dall-e-3" -
"gpt-image-1" -
"gpt-image-1-mini"
-
Images Response
-
ImagesResponse object { created, background, data, 4 more }The response from the image generation endpoint.
-
created: numberThe Unix timestamp (in seconds) of when the image was created.
-
background: optional "transparent" or "opaque"The background parameter used for the image generation. Either
transparentoropaque.-
"transparent" -
"opaque"
-
-
data: optional array of ImageThe list of generated images.
-
b64_json: optional stringThe base64-encoded JSON of the generated image. Returned by default for the GPT image models, and only present if
response_formatis set tob64_jsonfordall-e-2anddall-e-3. -
revised_prompt: optional stringFor
dall-e-3only, the revised prompt that was used to generate the image. -
url: optional stringWhen using
dall-e-2ordall-e-3, the URL of the generated image ifresponse_formatis set tourl(default value). Unsupported for the GPT image models.
-
-
output_format: optional "png" or "webp" or "jpeg"The output format of the image generation. Either
png,webp, orjpeg.-
"png" -
"webp" -
"jpeg"
-
-
quality: optional "low" or "medium" or "high"The quality of the image generated. Either
low,medium, orhigh.-
"low" -
"medium" -
"high"
-
-
size: optional "1024x1024" or "1024x1536" or "1536x1024"The size of the image generated. Either
1024x1024,1024x1536, or1536x1024.-
"1024x1024" -
"1024x1536" -
"1536x1024"
-
-
usage: optional object { input_tokens, input_tokens_details, output_tokens, 2 more }For
gpt-image-1only, the token usage information for the image generation.-
input_tokens: numberThe number of tokens (images and text) in the input prompt.
-
input_tokens_details: object { image_tokens, text_tokens }The input tokens detailed information for the image generation.
-
image_tokens: numberThe number of image tokens in the input prompt.
-
text_tokens: numberThe number of text tokens in the input prompt.
-
-
output_tokens: numberThe number of output tokens generated by the model.
-
total_tokens: numberThe total number of tokens (images and text) used for the image generation.
-
output_tokens_details: optional object { image_tokens, text_tokens }The output token details for the image generation.
-
image_tokens: numberThe number of image output tokens generated by the model.
-
text_tokens: numberThe number of text output tokens generated by the model.
-
-
-